<?php

//---------------------------------------------
// ADD YOUR SETTINGS AND AWS KEY HERE
//---------------------------------------------

define("Access_Key_ID", 'REPLACE_WITH_YOUR_ACCESS_KEY');
// path to cache WITHOUT trailing slash
$path_to_cache = 'cache';


//---------------------------------------------
//load gallery settings
//---------------------------------------------
    
if (file_exists('cube/3dcube.xml'))
{
    $xml = simplexml_load_file('cube/3dcube.xml');
}
else
{
    die('settings file is missing');
}

//---------------------------------------------
// prepare aws request
//---------------------------------------------

$Operation = "ItemSearch";
$Version = "2008-04-07";
$ResponseGroup = "Images,ItemAttributes";
$SearchIndex = "Music";
$Keywords = urlencode($_GET['key']);

$request_default=
     "http://ecs.amazonaws.com/onca/xml"
   . "?Service=AWSECommerceService"
   . "&AWSAccessKeyId=" . Access_Key_ID
   . "&Operation=" . $Operation
   . "&Version=" . $Version
   . "&SearchIndex=" . $SearchIndex
   . "&Keywords=" . $Keywords
   . "&ResponseGroup=" . $ResponseGroup;

// create an empty array
$images = array();

// 1 page is enough
$max_page = 1;

// every request returns max 10 results
for ($page = 1; $page <= $max_page; $page++)
{

  $request = $request_default . "&ItemPage=" .$page;

  //---------------------------------------------
  // use cURL to send the request
  //---------------------------------------------

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $request);
  curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_HEADER, 0);
  $response = curl_exec($ch);
  curl_close($ch);

  //---------------------------------------------
  // response to xml / verify response
  //---------------------------------------------

  $parsed_xml = simplexml_load_string($response);

  if ($parsed_xml->Items->Request->IsValid != "True")
  {
      if (!empty($parsed_xml->OperationRequest->Errors->Error))
      {
        foreach ($parsed_xml->OperationRequest->Errors->Error as $error)
        {
            echo "Error code: " . $error->Code . "\r\n";
            echo $error->Message . "\r\n";
            echo "\r\n";
        }
      } else {
       echo "No results. Did you submit a keyword?";
       echo "\r\n";
      }
      exit;
  }

  //---------------------------------------------
  // parse items
  //---------------------------------------------

  // get number of returnes items
  $numOfItems = $parsed_xml->Items->TotalResults;

  // there are max 10 results per page
  if ($numOfItems < 10)
  { 
    $page = $max_page;
  }
    
  if ($numOfItems > 0)
  {
      for ($i = 0; $i < $numOfItems; $i++)
      {
        $current = $parsed_xml->Items->Item[$i];
        
        if (!isset($current->MediumImage->URL))
        {
            // skip item if there's no image
            continue;
        }
        
        // get image url
        $img_url      = $current->MediumImage->URL;
          
        // get image filename
        $filename = end(explode('/', $img_url));
      
        // we will cache the image on the server
        if (!file_exists($path_to_cache.'/'.md5($filename).'.jpg'))
        {
            // store the image on the server (we will use the md5 hash as filename)
            $fp = fopen($path_to_cache.'/'.md5($filename).'.jpg', 'w');
            
            // use cURL to get the image
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $img_url);
            curl_setopt($ch, CURLOPT_FILE, $fp);
            curl_exec($ch);
            curl_close($ch);
            
            fclose($fp);
        }
        
        // create new item
        $item = array (
          'ImagePath' 			=>		'cache/'.md5($filename).'.jpg',
          'ImageLink'				=>		$current->DetailPageURL,
          'ImageLinkTarget' =>		'_blank',
          'Content1'				=>		'',
          'Content2'				=>		'',
          'JSFunction'			        =>		''
        );
        
        // add the item to the array
        array_push($images, $item);
      }
  }
}

//---------------------------------------------
//
//---------------------------------------------

foreach ($images as $entry)
{
	$tag = $xml->Images->addChild('Image');
	foreach ($entry as $key => $value)
	{
		$tag->addChild($key, '<![CDATA['.htmlentities($value).']]>');
	}
}

print_r(html_entity_decode($xml->asXML()));

?>